/**
 * Created by edwardtan on 2016/11/25.
 */
const XLSX = require('xlsx');

function _analysis (string) {
    let index = [];
    string.replace(/([a-z])([0-9]+)/gi, function (m, m1, m2) {
        index = index.concat([m1, m2]);
        return m;
    });

    return index;
}

function _range(range) {
    let index = _analysis(range);

    return {
        columnStart: index[0],
        column: index[2].charCodeAt(0) - index[0].charCodeAt(0) + 1,
        rowStart: parseInt(index[1]),
        row: parseInt(index[3]) - parseInt(index[1]) + 1
    }
}

function excel2Json (path) {
    let result = [];
    let workbook = XLSX.readFile(path);
    //处理excel数据
    //不处理样式问题
    let sheet_name_list = workbook.SheetNames;
    sheet_name_list.forEach(function(y) { /* iterate through sheets */
        let worksheet = workbook.Sheets[y];
        if ('!ref' in worksheet) {
            let one = { range: _range(worksheet['!ref']), data: [] };
            let rowStart = one.range.rowStart,
                row = parseInt(one.range.row),
                columnStart = one.range.columnStart.charCodeAt(0),
                column = parseInt(one.range.column);

            for (let i = 0, l = row; i < l; i++) {
                let r = [];
                for (let ii = 0, ll = column; ii < ll; ii++) {
                    let _c = String.fromCharCode(columnStart + ii);
                    let cell = worksheet[_c + (rowStart + i)];
                    r.push(cell ? cell.v : '');
                }
                one.data.push(r);
            }
            result.push(one);
        }
    });

    let data = [];
    for (let i = 0; i < result.length; i++) {
        let header = result[i].data[0];
        data[i] = data[i] || [];
        for (let j = 0; j < result[i].data.length; j++) {
            if (j != 0) {
                for (let k = 0; k < header.length; k++) {
                    if (header[k]) {
                        data[i][j - 1] = data[i][j - 1] || {};
                        data[i][j - 1][header[k]] = result[i].data[j][k];
                    }
                }
            }
        }
    }

    return data;
}

exports = module.exports = excel2Json;