const koa = require('koa');

const {DatahubRestfulCore} = require('../index');
let port = process.env.PORT || 3003;
let host = process.env.IP || '127.0.0.1';
const name = 'demo';
const endpoint = '/';
const session = require('koa-generic-session');

const app = koa();
app.keys = ['datahub'];

app.use(require('koa-body')())
app.use(session());

const core = new DatahubRestfulCore({
    port, host,
    name,
    endpoint,
    app,
    options:
        {
            client: 'mysql',
            connection: {
                host: '127.0.0.1',
                user: 'root',
                password: '',
                database: 'datahub',
                supportBigNumbers: true,
                bigNumberStrings: true,
                multipleStatements: true
            },
            acquireConnectionTimeout: 60000,
            pool: {min: 0, max: 2}
        }
});

let datahub = core.mount();

module.exports = {app:datahub, port, host, url: `http://${host}:${port}${endpoint}${name}`};
