
const tokenName = 'datahub_token'

/**
 * @param next
 */
function *privilege(next) {
    this.state.privilege = {table: {}, sqlmapping: {}, freeDatabase: new Map(this.knexHelper.freeDatabase)}
    let token = this.request.query[tokenName]
    if(token) {
        const api_list = yield this.knexHelper.getMetaConnection()
            .raw('select API.api from user_key_api_list API join ' + 
            '(select A.key as key from user_key_list A join tmp_token_list B on A.key = B.key where B.token = ? and B.expire_time > now()) ' + 
            'KEY on API.key = KEY.key', [token])
        api_list.forEach(element => {
            const list = element.api.split('.')
            if(list.length == 4) {
                if(list[0] == 1) {
                    if(!this.state.privilege.table[list[1]]) {
                        this.state.privilege.table[list[1]] = {}
                    }
                    if(!this.state.privilege.table[list[1]][list[2]]) {
                        this.state.privilege.table[list[1]][list[2]] = {}
                    }
                    this.state.privilege.table[list[1]][list[2]][list[3]] = true
                } else if(list[0] == 2) {
                    if(!this.state.privilege.sqlmapping[list[1]]) {
                        this.state.privilege.sqlmapping[list[1]] = {}
                    }
                    if(!this.state.privilege.sqlmapping[list[1]][list[2]]) {
                        this.state.privilege.sqlmapping[list[1]][list[2]] = {}
                    }
                    this.state.privilege.sqlmapping[list[1]][list[2]][list[3]] = true
                }
            }
        });
    }else if(this.state.userName) {
        const result = yield this.knexHelper.getMetaConnection().select('id').from('db_connection').where({owner: this.state.userName});
        result.forEach(e => this.state.privilege.freeDatabase.set('cdb_' + e.id, true));
    }
    yield next
}

module.exports = privilege;