const should = require('should');
const BasicAuthorizationProvider = require('../core/http/basic-authorization-provider');
const auth = new BasicAuthorizationProvider();

describe("Decode basic auth header", function () {

    it("should not be a valid basic header", function () {
        auth.extractAuthInfo('SGVsbG8gV29ybGQ=').username.should.eql('');
    });

    it("should be hello world", function () {
        const authInfo = auth.extractAuthInfo('Basic SGVsbG8gV29ybGQ=');
        authInfo.username.should.eql('Hello World');
        authInfo.password.should.eql('');
    });

    it("should be tommyhuo", function () {
        const authInfo = auth.extractAuthInfo('Basic dG9tbXlodW86');
        authInfo.username.should.eql('tommyhuo');
        authInfo.password.should.eql('');
    });

    it("should be hello world with empty password", function () {
        const authInfo = auth.extractAuthInfo('Basic SGVsbG8gV29ybGQ6');
        authInfo.username.should.eql('Hello World');
        authInfo.password.should.eql('');
    });

    it("should be hello world with password", function () {
        const authInfo = auth.extractAuthInfo('Basic SGVsbG8gV29ybGQ6cGFzcw==');
        authInfo.username.should.eql('Hello World');
        authInfo.password.should.eql('pass');
    });
});
