const HookExecutor = require('../middlewares/hook-executor');
const should = require('should');
const hookExecutor = new HookExecutor();
const qs = require('querystring');


describe("HookExecutor One hook", function () {

    it("should no a hook", function () {
        hookExecutor.hasHook(qs.parse('_hook:before=notahook')).should.be.false;
    });

    it("should be a hook", function () {
        hookExecutor.hasHook(qs.parse('_hook:before=reallyahook')).should.be.false;
    });

    it("should be a before hook", function () {
        hookExecutor.resolveHook(qs.parse('_hook:before=firstHook')).should.match({
            "before": [{"scriptName": 'firstHook'}]
        });
    });

    it("should be a after hook", function () {
        hookExecutor.resolveHook(qs.parse('_hook:after=firstHook')).should.match(
            {"after": [{"scriptName": 'firstHook'}]}
        );
    });

    it("should be a around hook", function () {
        hookExecutor.resolveHook(qs.parse('_hook:around=firstHook')).should.match(
            {"around": [{"scriptName": 'firstHook'}]}
        );
    });
})
;