const Parser = require('../core/sql/pegjs/parser')
const should = require('should');
const parser = new Parser();
let toSQL = require('../core/sql/sqlMysqlDialet');
describe(`pegjs Parser`, function () {
    it(`group by year`, function () {
        let p = parser.parse(" select count(*) time_count from db_healthopen_platform.t_wechat_ecardno group by YEAR(Fsend_template_time)")
        console.log('\n', toSQL(p));
    });

    it(`union all`, function () {
        let p = parser.parse("select * from T1 union all select * from T2 where a=:a")
        let contains = toSQL(p).toLowerCase().search('union all');
        console.log('\n', contains > -1);
        contains.should.not.eql(-1);
    });

    it(`union`, function () {
        let p = parser.parse("select * from T1 union select * from T2 where a=:a")
        let contains = toSQL(p).toLowerCase().search('union');
        console.log('\n', contains > -1);
        contains.should.not.eql(-1);
    });

    it(`union all 2`, function () {
        //SELECT `t8`.*, `t9`.`card_management_id`, `t9`.`city_id`, `t9`.`province_id`, `t9`.`hospital_name` FROM (SELECT `t6`.*, `t7`.`id` AS `tid`, `t7`.`apply_type`, `t7`.`synchronization_status`, `t7`.`submit_time`, `t7`.`active_apply_msg_id`, `t7`.`online_apply_msg_id`, `tt`.`check_status` FROM (SELECT `t1`.`id`, `t1`.`nick_name`, `t1`.`principal_name`, `t1`.`hospital_id`, `t1`.`user_name`, `t1`.`app_id`, `t1`.`create_time`, `t2`.`company_id`, `t1`.`id` AS `wx_account_id`, `t3`.`company_name`, `t3`.`app_id` AS `c_app_id`, `t4`.`type`, `t5`.`is_test`, `t5`.`is_inner` FROM db_open_platform_official.`t_wx_account_info` AS `t1` LEFT JOIN db_open_platform_official.`t_companys_wx_accounts` AS `t2` ON `t1`.`id` = `t2`.`wx_account_id` LEFT JOIN db_open_platform_official.`t_company_info` AS `t3` ON `t2`.`company_id` = `t3`.`id` LEFT JOIN (SELECT `a`.* FROM (SELECT * FROM db_open_platform_official.`t_wx_account_dev_msg` ORDER BY `submit_time` DESC, `id` DESC) AS `a` GROUP BY `a`.`wx_account_id`) AS `t4` ON `t1`.`id` = `t4`.`wx_account_id` LEFT JOIN db_open_platform_official.`t_wx_account_tags` AS `t5` ON `t1`.`id` = `t5`.`wx_account_id` WHERE `t1`.`hospital_id` = '20005') AS `t6` LEFT JOIN db_open_platform_official.`t_wx_account_check_record_admin` AS `t7` ON (`t6`.`wx_account_id` = `t7`.`wx_account_id` AND `t6`.`company_id` = `t7`.`company_id`) AND (`t7`.`apply_type` = 'wx_account_check_status' OR `t7`.`id` IS NULL) LEFT JOIN db_open_platform_official.`t_wx_account_check_result` AS `tt` ON (`t6`.`wx_account_id` = `tt`.`wx_account_id` AND `t6`.`company_id` = `tt`.`company_id`) AND (`tt`.`apply_type` = 'wx_account_check_status' OR `tt`.`id` IS NULL) ORDER BY `t7`.`submit_time` DESC, `t7`.`id` DESC) AS `t8` LEFT JOIN (SELECT `id`, `wx_account_id`, `card_management_id`, `city_id`, `province_id`, `hospital_name` FROM db_open_platform_official.`t_wx_account_dev_msg`) AS `t9` ON `t8`.`wx_account_id` = `t9`.`wx_account_id` WHERE `id` = id GROUP BY `t8`.`company_id`, `t8`.`wx_account_id``
        let p = parser.parse(`select t8.*,t9.card_management_id,t9.city_id,t9.province_id,t9.hospital_name from( select t6.*,t7.id tid,t7.apply_type,t7.synchronization_status,t7.submit_time,t7.active_apply_msg_id,t7.online_apply_msg_id,tt.check_status from(select t1.id,t1.nick_name,t1.principal_name,t1.hospital_id,t1.user_name,t1.app_id,t1.create_time,t2.company_id,t1.id wx_account_id,t3.company_name,t3.app_id c_app_id,t4.\`type\`,t5.is_test,t5.is_inner from db_open_platform_official.t_wx_account_info t1 left join db_open_platform_official.t_companys_wx_accounts t2 on t1.id=t2.wx_account_id left join db_open_platform_official.t_company_info t3 on t2.company_id=t3.id left join (select a.* from(select * from db_open_platform_official.t_wx_account_dev_msg order by submit_time desc,id desc)a group by a.wx_account_id) t4 on t1.id=t4.wx_account_id left join db_open_platform_official.t_wx_account_tags t5 on t1.id=t5.wx_account_id where t1.hospital_id ='20005') t6 left join db_open_platform_official.t_wx_account_check_record_admin t7 on (t6.wx_account_id = t7.wx_account_id and t6.company_id = t7.company_id) and (t7.apply_type ='wx_account_check_status' or t7.id is null) left join db_open_platform_official.t_wx_account_check_result tt on (t6.wx_account_id = tt.wx_account_id and t6.company_id = tt.company_id) and (tt.apply_type ='wx_account_check_status' or tt.id is null) order by t7.submit_time desc,t7.id desc) t8 left join ( SELECT id,wx_account_id,card_management_id,city_id,province_id,hospital_name FROM db_open_platform_official.t_wx_account_dev_msg UNION all SELECT id,wx_account_id,card_management_id,city_id,province_id,hospital_name FROM db_open_platform_official.t_wx_account_active_apply_msg ) t9 on t8.wx_account_id=t9.wx_account_id  where id=:id group by t8.company_id,t8.wx_account_id`);
        let contains = toSQL(p).toLowerCase().search('union all');
        console.log('\n', contains > -1);
        contains.should.not.eql(-1);
    });

    it(`union all 3`, function(){
        let p = parser.parse(`SELECT tt.* FROM (
            SELECT * FROM (
			    SELECT * FROM (
					SELECT wx_account_id, card_management_id, city_id, province_id
						, hospital_name, submit_time
					FROM t_wx_account_active_apply_msg
				    UNION ALL
					SELECT wx_account_id, card_management_id, city_id, province_id
						, hospital_name, submit_time
					FROM t_wx_account_dev_msg
				) table_temp1
				ORDER BY table_temp1.submit_time DESC
			) table_temp
			group by table_temp.wx_account_id
		) tt where tt.wx_account_id =:wx_account_id`)

        let contains = toSQL(p).toLowerCase().search('union all');
        console.log('\n', contains > -1);
        contains.should.not.eql(-1);
    })

    it(`union all with where`, function () {
        //SELECT `t8`.*, `t9`.`card_management_id`, `t9`.`city_id`, `t9`.`province_id`, `t9`.`hospital_name` FROM (SELECT `t6`.*, `t7`.`id` AS `tid`, `t7`.`apply_type`, `t7`.`synchronization_status`, `t7`.`submit_time`, `t7`.`active_apply_msg_id`, `t7`.`online_apply_msg_id`, `tt`.`check_status` FROM (SELECT `t1`.`id`, `t1`.`nick_name`, `t1`.`principal_name`, `t1`.`hospital_id`, `t1`.`user_name`, `t1`.`app_id`, `t1`.`create_time`, `t2`.`company_id`, `t1`.`id` AS `wx_account_id`, `t3`.`company_name`, `t3`.`app_id` AS `c_app_id`, `t4`.`type`, `t5`.`is_test`, `t5`.`is_inner` FROM db_open_platform_official.`t_wx_account_info` AS `t1` LEFT JOIN db_open_platform_official.`t_companys_wx_accounts` AS `t2` ON `t1`.`id` = `t2`.`wx_account_id` LEFT JOIN db_open_platform_official.`t_company_info` AS `t3` ON `t2`.`company_id` = `t3`.`id` LEFT JOIN (SELECT `a`.* FROM (SELECT * FROM db_open_platform_official.`t_wx_account_dev_msg` ORDER BY `submit_time` DESC, `id` DESC) AS `a` GROUP BY `a`.`wx_account_id`) AS `t4` ON `t1`.`id` = `t4`.`wx_account_id` LEFT JOIN db_open_platform_official.`t_wx_account_tags` AS `t5` ON `t1`.`id` = `t5`.`wx_account_id` WHERE `t1`.`hospital_id` = '20005') AS `t6` LEFT JOIN db_open_platform_official.`t_wx_account_check_record_admin` AS `t7` ON (`t6`.`wx_account_id` = `t7`.`wx_account_id` AND `t6`.`company_id` = `t7`.`company_id`) AND (`t7`.`apply_type` = 'wx_account_check_status' OR `t7`.`id` IS NULL) LEFT JOIN db_open_platform_official.`t_wx_account_check_result` AS `tt` ON (`t6`.`wx_account_id` = `tt`.`wx_account_id` AND `t6`.`company_id` = `tt`.`company_id`) AND (`tt`.`apply_type` = 'wx_account_check_status' OR `tt`.`id` IS NULL) ORDER BY `t7`.`submit_time` DESC, `t7`.`id` DESC) AS `t8` LEFT JOIN (SELECT `id`, `wx_account_id`, `card_management_id`, `city_id`, `province_id`, `hospital_name` FROM db_open_platform_official.`t_wx_account_dev_msg`) AS `t9` ON `t8`.`wx_account_id` = `t9`.`wx_account_id` WHERE `id` = id GROUP BY `t8`.`company_id`, `t8`.`wx_account_id``
        let p = parser.parse(`select t8.*,t9.card_management_id,t9.city_id,t9.province_id,t9.hospital_name from( select t6.*,t7.id tid,t7.apply_type,t7.synchronization_status,t7.submit_time,t7.active_apply_msg_id,t7.online_apply_msg_id,tt.check_status from(select t1.id,t1.nick_name,t1.principal_name,t1.hospital_id,t1.user_name,t1.app_id,t1.create_time,t2.company_id,t1.id wx_account_id,t3.company_name,t3.app_id c_app_id,t4.\`type\`,t5.is_test,t5.is_inner from db_open_platform_official.t_wx_account_info t1 left join db_open_platform_official.t_companys_wx_accounts t2 on t1.id=t2.wx_account_id left join db_open_platform_official.t_company_info t3 on t2.company_id=t3.id left join (select a.* from(select * from db_open_platform_official.t_wx_account_dev_msg order by submit_time desc,id desc)a group by a.wx_account_id) t4 on t1.id=t4.wx_account_id left join db_open_platform_official.t_wx_account_tags t5 on t1.id=t5.wx_account_id where t1.hospital_id ='20005') t6 left join db_open_platform_official.t_wx_account_check_record_admin t7 on (t6.wx_account_id = t7.wx_account_id and t6.company_id = t7.company_id) and (t7.apply_type ='wx_account_check_status' or t7.id is null) left join db_open_platform_official.t_wx_account_check_result tt on (t6.wx_account_id = tt.wx_account_id and t6.company_id = tt.company_id) and (tt.apply_type ='wx_account_check_status' or tt.id is null) order by t7.submit_time desc,t7.id desc) t8 left join ( SELECT id,wx_account_id,card_management_id,city_id,province_id,hospital_name FROM db_open_platform_official.t_wx_account_dev_msg where card_management_id=:card_management_id UNION all SELECT id,wx_account_id,card_management_id,city_id,province_id,hospital_name FROM db_open_platform_official.t_wx_account_active_apply_msg ) t9 on t8.wx_account_id=t9.wx_account_id  where id=:id group by t8.company_id,t8.wx_account_id`);
        let contains = toSQL(p).toLowerCase().search('union all');
        console.log('\n', contains > -1);
        contains.should.not.eql(-1);
    });

    it(`union all 3 times`, function () {
        //SELECT `t8`.*, `t9`.`card_management_id`, `t9`.`city_id`, `t9`.`province_id`, `t9`.`hospital_name` FROM (SELECT `t6`.*, `t7`.`id` AS `tid`, `t7`.`apply_type`, `t7`.`synchronization_status`, `t7`.`submit_time`, `t7`.`active_apply_msg_id`, `t7`.`online_apply_msg_id`, `tt`.`check_status` FROM (SELECT `t1`.`id`, `t1`.`nick_name`, `t1`.`principal_name`, `t1`.`hospital_id`, `t1`.`user_name`, `t1`.`app_id`, `t1`.`create_time`, `t2`.`company_id`, `t1`.`id` AS `wx_account_id`, `t3`.`company_name`, `t3`.`app_id` AS `c_app_id`, `t4`.`type`, `t5`.`is_test`, `t5`.`is_inner` FROM db_open_platform_official.`t_wx_account_info` AS `t1` LEFT JOIN db_open_platform_official.`t_companys_wx_accounts` AS `t2` ON `t1`.`id` = `t2`.`wx_account_id` LEFT JOIN db_open_platform_official.`t_company_info` AS `t3` ON `t2`.`company_id` = `t3`.`id` LEFT JOIN (SELECT `a`.* FROM (SELECT * FROM db_open_platform_official.`t_wx_account_dev_msg` ORDER BY `submit_time` DESC, `id` DESC) AS `a` GROUP BY `a`.`wx_account_id`) AS `t4` ON `t1`.`id` = `t4`.`wx_account_id` LEFT JOIN db_open_platform_official.`t_wx_account_tags` AS `t5` ON `t1`.`id` = `t5`.`wx_account_id` WHERE `t1`.`hospital_id` = '20005') AS `t6` LEFT JOIN db_open_platform_official.`t_wx_account_check_record_admin` AS `t7` ON (`t6`.`wx_account_id` = `t7`.`wx_account_id` AND `t6`.`company_id` = `t7`.`company_id`) AND (`t7`.`apply_type` = 'wx_account_check_status' OR `t7`.`id` IS NULL) LEFT JOIN db_open_platform_official.`t_wx_account_check_result` AS `tt` ON (`t6`.`wx_account_id` = `tt`.`wx_account_id` AND `t6`.`company_id` = `tt`.`company_id`) AND (`tt`.`apply_type` = 'wx_account_check_status' OR `tt`.`id` IS NULL) ORDER BY `t7`.`submit_time` DESC, `t7`.`id` DESC) AS `t8` LEFT JOIN (SELECT `id`, `wx_account_id`, `card_management_id`, `city_id`, `province_id`, `hospital_name` FROM db_open_platform_official.`t_wx_account_dev_msg`) AS `t9` ON `t8`.`wx_account_id` = `t9`.`wx_account_id` WHERE `id` = id GROUP BY `t8`.`company_id`, `t8`.`wx_account_id``
        let p = parser.parse(`select Fhospital_id from (SELECT \`Fauto_id\`, \`Fdrug_hash_id\`, \`Fdrug_name\`, \`Fspecification\`, \`Fmanufacturer\`, \`Fdrug_org_id\`, '10000' AS \`Fhospital_id\` FROM db_aid_drug_product.\`t_drug_product_10000\` UNION ALL SELECT \`Fauto_id\`, \`Fdrug_hash_id\`, \`Fdrug_name\`, \`Fspecification\`, \`Fmanufacturer\`, \`Fdrug_org_id\`, 10001 AS \`Fhospital_id\` FROM db_aid_drug_product.\`t_drug_product_10001\` UNION ALL SELECT \`Fauto_id\`, \`Fdrug_hash_id\`, \`Fdrug_name\`, \`Fspecification\`, \`Fmanufacturer\`, \`Fdrug_org_id\`, 10003 AS \`Fhospital_id\` FROM db_aid_drug_product.\`t_drug_product_10003\` UNION ALL SELECT \`Fauto_id\`, \`Fdrug_hash_id\`, \`Fdrug_name\`, \`Fspecification\`, \`Fmanufacturer\`, \`Fdrug_org_id\`, '10003' AS \`Fhospital_id\` FROM db_aid_drug_product.\`t_drug_product_10003\`) as T1 group by Fhospital_id`);
        let sql = toSQL(p).toLowerCase();
        let contains = sql.search('union all');
        console.log('\n', contains > -1);
        contains.should.not.eql(-1);
    });


});
